$fn = 100;

//Raspberry Pi mount point
raspi_m_l = 58;
raspi_m_w = 49;
raspi_m_shift_x = -10;
raspi_m_shift_y = 0;
raspi_m_d = 5;
raspi_m_screw_d = 2;
raspi_m_h = 6;
raspi_m_socket = 1;

ch_dis_x = 10;
ch_dis_y = 10;

// Servo dimensions
servo_w = 20;
servo_l = 40;
servo_lt = 53;
servo_h1 = 26.67;
servo_h2 = 9.35;
servo_h = servo_h1 + servo_h2;
servo_m_d = 10.15;
servo_m_l = (servo_lt-servo_l)/2;

servo_cut_w = 41;
servo_cut_h = 21;
servo_mount_x = 50/2;
servo_mount_d = 10;
servo_mount_d2 = 48.76;
servo_axis_offset = 9.66;

// Ball bearing
bb_di = 6;
bb_do = 19;
bb_h = 7;

// Screw dimensions
M3_hole = 3.4;
M3_nut_e = 6.4;
M4_hole = 4.4;

// Lens ring dimensions
lr_h = 10;
lr_di = 38.3;
lr_di2 = 40.5;
lr_h_shift = 35;

// wide angle lens dimensions
lrw_di = 30;
lrw_di2 = 30;
lrw_h = 5;

s1_teeth = 40;
s2_teeth = 21;
s3_teeth = 21;



Assembled = 0;

if(Assembled){
  translate([30, 0, 80-2])rotate([0, 0, 0]){
    base_plate(100, 8, 2);
  }
  translate([0, 0, lr_h_shift+80])rotate([0, 90, 0]){
    lens_ring(10, lrw_di, 65, 2);
  }
  translate([-5, 43, lr_h_shift+80])rotate([0, 90, 0]){
    servo_gear(s3_teeth);
  }
  translate([50, 43, 45+80])rotate([0, -90, 0]){
    servo();
  }
  translate([35, 68, 0+80])rotate([0, 0, 180]){
    servo_mount();
  }
  translate([-18, 0, 33+80])rotate([0, 90, 0]){
    mount_ring(2);
  }


  translate([60, 0, -2])rotate([0, 0, 0]){
    base_plate();
  }

  translate([0, 0, lr_h_shift])rotate([0, 90, 0]){
    lens_ring(10, lr_di, 64, 1);
  }
  translate([0, -55, lr_h_shift])rotate([0, 90, 0]){
    servo_gear(s1_teeth);
  }
  translate([55, -55, 45])rotate([0, -90, 0]){
    servo();
  }
  translate([40, -80, 0])rotate([0, 0, 0]){
    servo_mount();
  }

  translate([15, 0, lr_h_shift])rotate([0, 90, 0]){
    lens_ring(10, lr_di, 50, 1);
  }
  translate([15, 43, lr_h_shift])rotate([0, 90, 0]){
    servo_gear(s2_teeth);
  }
  translate([70, 43, 45])rotate([0, -90, 0]){
    servo();
  }
  translate([55, 68, 0])rotate([0, 0, 180]){
    servo_mount();
  }
  translate([-18, 0, 33])rotate([0, 90, 0]){
    mount_ring(1);
  }

  translate([30, 107, 45])rotate([90, 90, 0]){
    connection_plate();
  }
  translate([30, -105, 45])rotate([90, 90, 0]){
    connection_plate();
  }

  translate([-22, 80, 45])rotate([0, 90, 0]){
    connection_plate_front();
  }
  translate([-22, -80, 45])rotate([0, 90, 0]){
    connection_plate_front();
  }

  translate([40, -0, -20])rotate([90, 0, 270]){
    pivot_frame_vertical();
  }

  translate([70, 0, -89])rotate([0, 0, 0]){
    socket();
    translate([23, 10, 2])rotate([0, 0, 90]){
      servo();
    }
    translate([48, 10, 2])rotate([0, 0, 90]){
      servo_mount_socket();
    }
    translate([-35, 0, 2])rotate([0, 0, 0]){
      bearing_mount();
    }
  }
  
  translate([100, -13, 0])rotate([0, 0, 90]){
    pi_mount();
  }
}
else{
//  base_plate();
//  translate([-26, 0, 0])cube(size=[42, 10, 10], center=true);
//  base_plate(100, 8, 2);
//  connection_plate();
//  connection_plate_front();
//  lens_ring(10, lr_di, 64, 1);
  lens_ring(10, lr_di, 60, 1);
//  lens_ring(10, lrw_di, 65, 2);
//  servo_mount();
//    mount_ring(1);
//    mount_ring(2);
//    pi_mount();
//  servo_gear(s3_teeth);
//  servo_gear(s2_teeth);  
//  translate([60, 0, 0]){
//    servo_gear(s1_teeth);
//  }
//  pivot_frame_vertical(6);
//  socket();
//  servo_mount_socket();
//  bearing_mount();
//  camera_foot();
//  pi_spacer();
//  pi_spacer(11);
//  buck_converter_mount();
//  servo_clamp();

  
}


module buck_converter_mount(){
  bcm_l = 50;
  bcm_w = 80;
  bcm_wall = 2;
  bcm_h = 5;
  bcm_shift = 27.5;
  
  // Mount on chassis
  hole_d = 4.5;
  hole_x = 20;
  hole_y = 40;
  hole_shift_x = -5;
  hole_shift_y = -5;
  
  
  // Converter board dimensions
  bc_l = 43.5;
  bc_w = 21.5;
  screw_x = bc_l/2 - 6.5;
  screw_y = bc_w/2 - 2.5;
  
  difference(){
    union(){
      roundedRect([bcm_l, bcm_w, bcm_wall], 3);
      translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
      translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
    }

    //Chassis mount holes
    translate([hole_shift_x, hole_shift_y, bcm_h/2]){
      cylinder(d=M3_hole, h=bcm_h*1.1, center=true);
    }
    translate([hole_shift_x+hole_x, hole_shift_y+hole_y, bcm_h/2]){
      cylinder(d=M3_hole, h=bcm_h*1.1, center=true);
    }

    //Board mount holes
    translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
    translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
  }
  
  translate([33, 0, 0]){
    pi_spacer(15);
  }
  translate([33, 15, 0]){
    pi_spacer(15);
  }
  
}


module pi_spacer(ps_h = 9){
  ps_d = 10;
  
  translate([0, 0, ps_h/2]){
    difference(){
      cylinder(d=ps_d, h=ps_h, center=true);
      cylinder(d=M3_hole, h=ps_h*1.1, center=true);
    }
  }
}

module camera_foot(){
  cf_d1 = 5.4;
  cf_d2 = 25;
  cf_h1 = 8.5;
  cf_h2 = 1.5;
  cf_wall = 2;
  
  translate([0, 0, cf_wall/2]){
    cylinder(d=cf_d2, h=cf_wall, center=true);
  }
  translate([0, 0, cf_h1/2]){
    cylinder(d=cf_d1, h=cf_h1, center=true);
  }
  translate([0, 0, cf_h1 + cf_h2/2]){
    cylinder(d1=cf_d1, d2=cf_d1*0.8, h=cf_h2, center=true);
  }
}

module bearing_mount(){
  bm_w = 100;
  bm_l = 90;
  bm_wall = 3;
  bm_h = 47;
  bm_d1 = 90;
  bm_d2 = 25;
  
  //mount screw holes distance
  ms_dis = 80;
  
  difference(){
    union(){
      roundedRect([bm_l, bm_w, bm_wall], 5);
      translate([0, 0, bm_h/2]){
        cylinder(d1=bm_d1, d2=bm_d2, h=bm_h, center=true);
      }
    }
    // Ball bearing cuts
    translate([0, 0, bm_h-bb_h/2]){
      cylinder(d=bb_do+0.2, h=bb_h+0.2, center=true);
    }
    translate([0, 0, bm_h/2]){
      cylinder(d=bb_do-5, h=bm_h*1.1, center=true);
    }
    translate([0, 0, bb_h/2]){
      cylinder(d=bb_do+0.2, h=bb_h+0.2, center=true);
    }
    translate([0, 0, bb_h+2.08]){
      cylinder(d1=bb_do+0.2, d2=bb_do-5, h=4, center=true);
    }
    //Wrench cut
    translate([0, 30, 30]){
//      cube(size=[30, 60, 10], center=true);
    }
    // mount holes
    translate([ms_dis/2, ms_dis/2, bm_wall/2]){
      cylinder(d=M3_hole, h=bm_wall*1.1, center=true);
    }
    translate([-ms_dis/2, ms_dis/2, bm_wall/2]){
      cylinder(d=M3_hole, h=bm_wall*1.1, center=true);
    }
    translate([-ms_dis/2, -ms_dis/2, bm_wall/2]){
      cylinder(d=M3_hole, h=bm_wall*1.1, center=true);
    }
    translate([ms_dis/2, -ms_dis/2, bm_wall/2]){
      cylinder(d=M3_hole, h=bm_wall*1.1, center=true);
    }
  }
}

module socket(){
  s_w = 100;
  s_l = 160;
  s_h = 15;
  s_wall = 2;
  pivot_shift = 30;

  difference(){
    roundedRect([s_l, s_w, s_h], 5);
    translate([0, 0, s_wall]){
      roundedRect([s_l-2*s_wall, s_w-2*s_wall, s_h], 5);
    }
    // Mount holes grid bottom
    dis_x = 10;
    dis_y = 10;
    bg_holes_x = 14;
    bg_holes_y = 8;
    
    for(j=[0:1:bg_holes_y]){
      translate([0, (j-bg_holes_y/2)*dis_y, 8]){
        for(i=[0:1:bg_holes_x]){
          translate([(i-bg_holes_x/2)*dis_x, 0, 8]){
            cylinder(d=M3_hole, h=250, center=true);
          }
        }
      }
    }
    
    // Mount holes walls
    holes_no_x = 14;
    for(i=[0:1:holes_no_x]){
      translate([(i-holes_no_x/2)*10, 0, 8]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=250, center=true);
        }
      }
    }
    holes_no_y = 8;
    for(i=[0:1:holes_no_y]){
      translate([0, (i-holes_no_y/2)*10, 8]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=250, center=true);
        }
      }
    }
    // Mount point Camera screw
    mpcs_shift_x = 55;
    mpcs_d = 12.5;
    translate([-pivot_shift, 0, 0]){
      cylinder(d=mpcs_d, h = s_wall*2.1, center=true);
    }

  }

  
}

module pivot_frame_vertical(part = 0){
  pfv_e1 = 20;
  pfv_e2 = 10;
  pf_l = 140;
  pf_l2 = 60;
  pf_wall = 2;
  tolerance = 0.2;
  
  slit_l = 25;
  slit_edge = 5;
  
  // Servo dimensions
  s_m_d = 25;
  s_shift_x = 10;
  s_shift_y = 15;
  
  //left part with servo
  pfvl_l = 100;
  pfvl_h = 120;

  //right part with screw only
  pfvr_l = 90;
  pfvr_h = 120;
  
  // Gear mount distance
  gmd = 40;

  if(part == 0 || part == 1)
  // Gear pivot point
  translate([0, -13, 6])rotate([90*Assembled, 0, 0]){
    difference(){
      gear(teeth=55,h=lr_h, shaft=6.2);
      translate([gmd/2, 0, 0]){
        cylinder(d=M3_hole, h = lr_h*2.1, center=true);
      }
      translate([-gmd/2, 0, 0]){
        cylinder(d=M3_hole, h = lr_h*2.1, center=true);
      }
    }
  }
  if(part == 0 || part == 2)
  // Gear pivot servo
  translate([0, -13, -53])rotate([90*Assembled, 0, 0]){
    difference(){
      gear(teeth=55,h=lr_h, shaft=9);
      translate([13.7, 0, 0]){
        cylinder(d=M3_hole, h = lr_h*2.1, center=true);
      }
      translate([-13.7, 0, 0]){
        cylinder(d=M3_hole, h = lr_h*2.1, center=true);
      }
    }
  }

  if(part == 0 || part == 3)
  // Center part
  translate([0, 0, (pfv_e2+pf_wall)/2]){
    difference(){
      cube(size=[pf_l, pfv_e1+2*pf_wall, pfv_e2+pf_wall], center=true);
      translate([(pf_l+pf_l2)/2, 0, pf_wall+0.1]){
        cube(size=[pf_l, pfv_e1+tolerance, pfv_e2], center=true);
      }
      translate([-(pf_l+pf_l2)/2, 0, pf_wall+0.1]){
        cube(size=[pf_l, pfv_e1+tolerance, pfv_e2], center=true);
      }
      // Pivot point
      translate([0, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=6.2, h=pfv_e1*2.1, center=true);
        }
      }
      // Gear mount holes
      translate([gmd/2, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=pfv_e1*2.1, center=true);
        }
      }
      translate([-gmd/2, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=pfv_e1*2.1, center=true);
        }
      }
      // Slits mounts left & right
      hull(){
        translate([pf_l/2-slit_edge, 0, 0]){
          cylinder(d=M3_hole, h = pfv_e2*2.1, center=true);
        }
        translate([pf_l/2-slit_edge-slit_l, 0, 0]){
          cylinder(d=M3_hole, h = pfv_e2*2.1, center=true);
        }
      }
      hull(){
        translate([-pf_l/2+slit_edge, 0, 0]){
          cylinder(d=M3_hole, h = pfv_e2*2.1, center=true);
        }
        translate([-pf_l/2+slit_edge+slit_l, 0, 0]){
          cylinder(d=M3_hole, h = pfv_e2*2.1, center=true);
        }
      }
    }
  }
  
  if(part == 0 || part == 4)
  // Left part
  translate([(pfvl_l+pf_l)/2-25, 0, 0]){  
    difference(){
      union(){
        translate([0, 0, 0]){
          roundedRect([pfvl_l, pfv_e1, pfv_e2], 5, [1,1,1,1]);
        }
        translate([(pfvl_l-pfv_e1)/2, (pfvl_h-pfv_e2)/2, pfv_e2/2]){
          cube(size=[pfv_e1, pfvl_h, pfv_e2], center=true);
        }
        translate([(pfvl_l-pfv_e1)/2, pfvl_h-pfv_e2/2, pfv_e2/2]){
          cylinder(d=pfv_e1, h=pfv_e2, center=true);
        }
      }
      // Center mount hole
      translate([10-pfvl_l/2, 0, pfv_e2/2]){
        cylinder(d=M3_hole, h=pfv_e2*1.1, center=true);
      }
      // Servo clamp holes
      translate([(pfvl_l-pfv_e1)/2, pfvl_h-pfv_e2/2, pfv_e2/2]){
        cylinder(d=M3_hole, h=pfv_e2*1.1, center=true);
      }
      translate([(pfvl_l-pfv_e1)/2, pfvl_h-pfv_e2/2-s_m_d*2, pfv_e2/2]){
        cylinder(d=M3_hole, h=pfv_e2*1.1, center=true);
      }
    }
  }

  if(part == 0 || part == 5)  // Right part
  translate([30-(pfvr_l+pf_l)/2, 0, 0]){  
    difference(){
      a=-(pfvr_l-pfv_e1)/2;
      b=pfvr_h-pfv_e2/2-s_shift_y;
      c=pfv_e2+s_shift_x;
      union(){
        translate([0, 0, 0]){
          roundedRect([pfvr_l, pfv_e1, pfv_e2], 5, [1,1,1,1]);
        }
        translate([-(pfvr_l-pfv_e1)/2, b/2, pfv_e2/2]){
          cube(size=[pfv_e1, b, pfv_e2], center=true);
        }
        translate([-(pfvr_l-pfv_e1)/2, pfvr_h-pfv_e2/2, pfv_e2/2]){
//          cylinder(d=pfv_e1, h=pfv_e2, center=true);
        }
        translate([a, b, c]){
          rotate([0, 90, 0]){
            cylinder(d=pfv_e1, h=pfv_e1, center=true);
          }
        }
        translate([a, b, (pfv_e2+s_shift_x)/2]){
          cube(size=[pfv_e1, pfv_e1, pfv_e2+s_shift_x], center=true);
        }
      }
      // Center mount hole
      translate([pfvr_l/2-10, 0, pfv_e2/2]){
        cylinder(d=M3_hole, h=pfv_e2*1.1, center=true);
      }
      // Pivot point
      translate([a, b, c]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=pfv_e1*1.1, center=true);
        }
      }

    }
  }

  if(part == 0 || part == 6)  // Servo horn mount
  translate([0, 0, pf_wall/2]){  
    difference(){
      cylinder(d=50, h=pf_wall, center=true);
      cylinder(d=9, h=pf_wall*1.1, center=true);
      
      horn_r = 13.7;
      for(i=[0:1:3]){
        rotate([0, 0, 45+i*90]){
          translate([horn_r, 0, 0]){
            cylinder(d=M3_hole, h=pf_wall*1.1, center=true);
          }
        }
      }

      for(i=[0:1:3]){
        rotate([0, 0, i*90]){
          translate([20, 0, 0]){
            cylinder(d=M3_hole, h=pf_wall*1.1, center=true);
          }
        }
      }
    }
  }
  
  
}

module connection_plate(){
  cp_l = 95;
  cp_w = 90;
  cp_wall = 2;
  
  translate([0, 0, 0]){
    difference(){
      roundedRect([cp_l, cp_w, cp_wall], 5);
      dis_x = 10;
      dis_y = 10;
      bg_holes_x = 8;
      bg_holes_y = 8;
      
      for(j=[0:1:bg_holes_y]){
        translate([0, (j-bg_holes_y/2)*dis_y, 8]){
          for(i=[0:1:bg_holes_x]){
            translate([(i-bg_holes_x/2)*dis_x, 0, 8]){
              cylinder(d=M3_hole, h=250, center=true);
            }
          }
        }
      }
    }
  }
}

module connection_plate_front(){
  cp_l = 95;
  cp_w = 30;
  cp_wall = 2;
  
  translate([0, 0, 0]){
    difference(){
      roundedRect([cp_l, cp_w, cp_wall], 5);
      dis_x = 10;
      dis_y = 10;
      bg_holes_x = 8;
      bg_holes_y = 2;
      
      for(j=[0:1:bg_holes_y]){
        translate([0, (j-bg_holes_y/2)*dis_y, 8]){
          for(i=[0:1:bg_holes_x]){
            translate([(i-bg_holes_x/2)*dis_x, 0, 8]){
              cylinder(d=5, h=250, center=true);
            }
          }
        }
      }
    }
  }
}

module base_plate(bp_l =160,  bg_holes_x = 14, type = 1){
  bp_w = 210;
  bp_wall = 2;
  bp_h = 15;
  
  difference(){
    roundedRect([bp_l, bp_w, bp_h], 5);
    translate([0, 0, bp_wall]){
      roundedRect([bp_l-2*bp_wall, bp_w-2*bp_wall, bp_h], 5);
    }
    // Mount holes grid bottom
    dis_x = 10;
    dis_y = 10;
    bg_holes_y = 19;
    
    for(j=[0:1:bg_holes_y]){
      translate([0, (j-bg_holes_y/2)*dis_y, 8]){
        for(i=[0:1:bg_holes_x]){
          translate([(i-bg_holes_x/2)*dis_x, 0, 8]){
            if(!(i == 5 - (type-1)*2 && j == 9) &&
              !(i == 5 - (type-1)*2 && j == 10)){
              cylinder(d=M3_hole, h=250, center=true);
            }
          }
        }
      }
    }
    
    
    // Mount holes walls
    holes_no_x = 14;
    for(i=[0:1:holes_no_x]){
      translate([(i-holes_no_x/2)*10, 0, 8]){
        rotate([90, 0, 0]){
          if((type == 2 && i>2 && i<12) || type == 1){
            cylinder(d=M3_hole, h=250, center=true);
          }
        }
      }
    }
    holes_no_y = 18;
    for(i=[0:1:holes_no_y]){
      translate([0, (i-holes_no_y/2)*10, 8]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=250, center=true);
        }
      }
    }
    // Mount point Camera screw
    mpcs_shift_x = 55;
    mpcs_d = 6.5;
    translate([(15-bp_l)/2+mpcs_shift_x-(type-1)*18, 0, 0]){
      cylinder(d=mpcs_d, h = bp_wall*2.1, center=true);
    }
    // Mount points servos
    translate([10, 65, 0]){
//      cylinder(d=M3_hole, h = bp_wall*2.1, center=true);
    }
    translate([-20, 65, 0]){
//      cylinder(d=M3_hole, h = bp_wall*2.1, center=true);
    }

    translate([-5, -80, 0]){
      cylinder(d=M3_hole, h = bp_wall*2.1, center=true);
    }
    translate([-35, -80, 0]){
      cylinder(d=M3_hole, h = bp_wall*2.1, center=true);
    } 
  }
    
}

module mount_ring(type = 1){
  // Mount ring clamp

  mr_h = 65;
  mr_l = 55;
  mr_cut = 8;
  mr_r = 5;
  mr_w = 12;
  mr_w2 = 10;
  mr_screw_h1 = 60;
  mr_screw_h2 = 10;
  // Mount ring

  translate([0, 0, 0]){
    difference(){
      roundedRect([mr_h, mr_l, mr_w], 3, [1,1,1,1]);
      // Gap
      cube(size=[mr_h*1.1, mr_cut, mr_w*2.1], center=true);
      // Lens cut
      translate([mr_h/2-lr_h_shift, 0, mr_w/2]){
        if(type == 1){
          cylinder(d=lr_di2, h=mr_w*1.1, center=true);
        }
        else{
          cylinder(d=lrw_di2, h=mr_w*1.1, center=true);
        }
      }
      // Lens mount screw cut
      translate([mr_h/2-mr_screw_h1, 0, mr_w/2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=100, center=true);
        }
      }
      translate([mr_h/2-mr_screw_h2, 0, mr_w/2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=100, center=true);
        }
      }
      // Bottom mount slit
      for(i=[0:1:1])mirror([0, i, 0]){
        hull(){
          translate([mr_h/2-5, 21, mr_w/2]){
            cylinder(d=M3_hole, h=100, center=true);
          }
          translate([mr_h/2-5, 9, mr_w/2]){
            cylinder(d=M3_hole, h=100, center=true);
          }
        }
      }
      
    }
  }

}

module servo_gear(teeth_no = 25){
  horn_d1 = 14.5;
  horn_d2 = 13.7*2;
  
  difference(){
    gear(teeth=teeth_no,h=lr_h, shaft=2);
    translate([0, 0, lr_h/2]){
      cylinder(d=9, h=lr_h*1.1, center=true);
    }
    
    if(teeth_no < 35){
      translate([0, horn_d1/2, lr_h/2]){
        cylinder(d=M3_hole, h=lr_h*1.1, center=true);
      }
      translate([0, -horn_d1/2, lr_h/2]){
        cylinder(d=M3_hole, h=lr_h*1.1, center=true);
      }
    }
    else{    
      translate([0, horn_d2/2, lr_h/2]){
        cylinder(d=M3_hole, h=lr_h*1.1, center=true);
      }
      translate([0, -horn_d2/2, lr_h/2]){
        cylinder(d=M3_hole, h=lr_h*1.1, center=true);
      }
    }
  }
}

module lens_ring(lr_h = 10, lrd = 10, lr_teeth = 60, type = 1){
  
  difference(){
    gear(teeth=lr_teeth,h=lr_h, shaft=lrd);
    translate([0, 0, lr_h/8-0.05]){
      cylinder(d1=lrd*1.15, d2=lrd, h=lr_h/4, center=true);
    }
    translate([0, 0, lr_h-lr_h/8+0.05]){
      cylinder(d2=lrd*1.15, d1=lrd, h=lr_h/4, center=true);
    }
    translate([0, 50+lrd/2+2, lr_h/2]){
      rotate([90, 0, 0]){
        cylinder(d=6, h=100, center=true);
        cylinder(d=2.5, h=150, center=true);
      }
    }
  }
  
} 

module gear(teeth = 10,h = 5, shaft=M3_hole){
  mod = 3;
  alpha = 180/teeth;
  r1 = mod*teeth/(2*3.14159);
  r=(mod/2)/tan(alpha);
  edge = 1;
  
  difference(){
    union(){
      x1=r;
      y1=mod/2;
      x2=r+mod;
      y2=0;
      x3=r;
      y3=-mod/2;
      x4=0;
      y4=0;
      translate([0, 0, edge]){
        linear_extrude(height=h-edge){
          for(i=[0:1:teeth]){
            rotate([0, 0, i*360/teeth]){
              polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
            }
          }
        }
      }
      translate([0, 0, edge]){
        mirror([0, 0, 1]){
          linear_extrude(height=edge, scale=[0.97, 0.97]){
            for(i=[0:1:teeth]){
              rotate([0, 0, i*360/teeth]){
                polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
              }
            }
          }
        }
      }
    }
    translate([0, 0, h/2]){
      cylinder(d=shaft, h=h*1.1, center=true);
    }
    if(shaft==-1){
      translate([0, 0, h/2]){
        difference(){
          cylinder(d=motor_shaft, h=h*1.1, center=true);
          translate([0, motor_shaft_shift, 0]){
            cube(size=[motor_shaft, motor_shaft, 16], center=true);
          }
        }
      }
    }
  }
  
}

module pi_mount(){
  pm_wall = 2;
  pm_w = 74;
  pm_l = 100;
  
  wall_h = 8;
  mount_holes_x = 29;
  
  tower_m_d = 20;
  tower_m_x = -5;
  
  //Central cut
  cc_d = 20;
  cc_l = 25;
  
  //micro USB power supply cut
  psc_d = 50;
  psc_x = -30;
  psc_z = 27;

  
  translate([0, 0, pm_wall/2]){
    block_l = 4;
    block_w = 35;
    block_h = servo_w+5;
    block_edge = 8;

    
    difference(){
      union(){
        cube(size=[pm_l, pm_w, pm_wall], center=true);
        //Pi mount points
        translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall/2]){
          translate([raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
        }
        //Walls
        translate([(pm_l-pm_wall)/2, 0, raspi_m_h/2]){
          cube(size=[pm_wall, pm_w, raspi_m_h], center=true);
        }
        translate([(pm_l-pm_wall)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 35]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([(pm_wall-pm_l)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 33]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([0, (pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
        translate([0, -(pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
      }
      //Mount holes on chassis
      translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5-4.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      //Central hole
      hull(){
        translate([cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
        translate([-cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
      }
      //Mount holes power pole
      holes = 9;
      for(i=[1:1:holes]){
        translate([-pm_l/2+i*ch_dis_x, pm_w/2, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }
        translate([-pm_l/2+i*ch_dis_x, pm_w/2-pm_wall*1.5, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        if(i>3){
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
            }
          }
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2+pm_wall*1.5, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
            }
          }
        }

      }
      // Cut micro USB for power supply
      translate([psc_x, -pm_w/2, psc_z]){
        rotate([90, 0, 0]){
          cylinder(d=psc_d, h=pm_wall*2.1, center=true);
        }
      }
      
      //Pi mount holes
      translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall]){
        translate([raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
      }
      
    }
    
  }
}

module servo_mount_socket(){
  
  s_w = 60;
  s_w2 = 66;
  s_l = 30;
  s_h = 35;
  s_wall = 2;

  // Clamp position
  c_mount_holes = 25;
  c_shift = 7.5;
  
  enf_l = 25;
  enf_h = 25;
  

  // Servo mount plate
  translate([s_h/2*(1-Assembled), 0, s_l/2*(1-Assembled)]){
    rotate([270*(1-Assembled), 0, 90*(1-Assembled)]){
      difference(){
        union(){
          roundedRect([s_w2, s_l, s_wall], 5, [1,1,1,1]);
          translate([0, s_l/2, s_h/2]){
            rotate([90, 0, 0]){
              difference(){
                roundedRect([s_w, s_h, 7], 5, [0,0,1,1]);
                translate([0, 0, s_wall]){
                  roundedRect([s_w-2*s_wall, s_h-2*s_wall, 7], 5, [0,0,1,1]);
                }
              }
            }
          }
          hull(){
            translate([(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          hull(){
            translate([-(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([-(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          // Clamp mount points
          translate([c_mount_holes, s_l/2-3, s_h/2]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=6, center=true);
            }
          }    
          translate([-c_mount_holes, s_l/2-3, s_h/2]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=6, center=true);
            }
          }    
        }
        // Clamp mount holes
        translate([c_mount_holes, s_l/2-3, s_h/2]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=6.1, center=true);
            translate([0, 0, s_wall]){
              cylinder(d=M3_nut_e, h=6.0, center=true, $fn=6);
            }
          }
        }    
        translate([-c_mount_holes, s_l/2-3, s_h/2]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=6.1, center=true);
            translate([0, 0, s_wall]){
              cylinder(d=M3_nut_e, h=6.0, center=true, $fn=6);
            }
          }
        }    
        // Bottom mount holes
        for(i=[0:1:1])mirror([i, 0, 0]){
          hull(){
            translate([15, 7.5, 0]){
              cylinder(d=M3_hole, h=20.1, center=true);
            }    
            translate([15, -7.5, 0]){
              cylinder(d=M3_hole, h=20.1, center=true);
            }    
          }
        }
      }
    }
    
  }
  translate([0, 20, 0]){
    servo_clamp(c_mount_holes);
  }

}


module servo_mount(){
  
  s_w = 20;
  s_w2 = 50;
  s_l = 30;
  s_h = 75;
  s_wall = 2;

  // Clamp position
  c_mount_holes = 25;
  c_shift = 7.5;
  
  enf_l = 25;
  enf_h = 55;
  

  // Servo mount plate
  translate([s_h/2*(1-Assembled), 0, s_l/2*(1-Assembled)]){
    rotate([270*(1-Assembled), 0, 90*(1-Assembled)]){
      difference(){
        union(){
          roundedRect([s_w2, s_l, s_wall], 5, [1,1,1,1]);
          translate([0, s_l/2, s_h/2]){
            rotate([90, 0, 0]){
              difference(){
                roundedRect([s_w, s_h, 7], 5, [0,0,1,1]);
                translate([0, 0, s_wall]){
                  roundedRect([s_w-2*s_wall, s_h-2*s_wall, 7], 5, [0,0,1,1]);
                }
              }
            }
          }
          hull(){
            translate([(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          hull(){
            translate([-(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([-(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          // Clamp mount points
          translate([0, s_l/2-3, s_h/2-c_mount_holes+c_shift]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=6, center=true);
            }
          }    
          translate([0, s_l/2-3, s_h/2+c_mount_holes+c_shift]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=6, center=true);
            }
          }    
        }
        // Clamp mount holes
        translate([0, s_l/2-3, s_h/2-c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=6.1, center=true);
            translate([0, 0, s_wall]){
              cylinder(d=M3_nut_e, h=6.0, center=true, $fn=6);
            }
          }
        }    
        translate([0, s_l/2-3, s_h/2+c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=6.1, center=true);
            translate([0, 0, s_wall]){
              cylinder(d=M3_nut_e, h=6.0, center=true, $fn=6);
            }
          }
        }    
        // Bottom mount holes
        for(i=[0:1:1])mirror([i, 0, 0]){
          hull(){
            translate([15, 7.5, 0]){
              cylinder(d=M3_hole, h=20.1, center=true);
            }    
            translate([15, -7.5, 0]){
              cylinder(d=M3_hole, h=20.1, center=true);
            }    
          }
        }
      }
    }
    
  }

  servo_clamp(c_mount_holes);

}

module servo_clamp(c_mount_holes = 25){
  c_l = 57;
  c_w = 10;
  c_h = 15;

  translate([Assembled*5-5, 20-Assembled*-12, 38*Assembled+c_h/2]){
    rotate([90*Assembled, 90*Assembled, 0]){
      difference(){
        cube(size=[c_l, c_w, c_h], center=true);
        translate([0, 0, 4]){
          cube(size=[42, c_w*1.1, c_h], center=true);
        }
        translate([c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
        translate([-c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
      }
    }
  }
}

module servo(tolerance=0, mount_holes=1){
  mh_dis1 = 50.5;
  mh_dis2 = 10;
  
  translate([0, 0, servo_h/2]){
    cube(size=[servo_l+tolerance, servo_w+tolerance, servo_h+tolerance], center=true);
    translate([servo_axis_offset-servo_l/2, 0, 25]){
      rotate([0, 0, 90]){
        cylinder(d=30, h=2, center=true);
      }
    }
  }
  translate([0, 0, servo_h1+1]){
    cube(size=[servo_lt, servo_w+tolerance, 3], center=true);
  }
  if(mount_holes == 1){
    translate([-servo_l/2, 0, servo_h/2]){
      cylinder(d=7, h=servo_h, center=true);
    }
    translate([mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
  }

  
}

module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}

